local WM = wMerchant


function WM:HideAllSalesFrame()
	wMerchantDisplaySearchBox:SetHidden(true)
	wMerchantDisplayFrame:SetHidden(true)
	wMerchantDisplayTB:SetHidden(true)
end

function WM:ShowAllSalesFrame()
	wMerchantDisplaySearchBox:SetHidden(false)
	wMerchantDisplayFrame:SetHidden(false)
	wMerchantDisplayTB:SetHidden(false)
end


--- DoSearch
function WM.DoSearch(searchText)
	-- local ITEMDATA_FIELD_ID = 1
	-- local ITEMDATA_FIELD_NAME = 2
	-- local ITEMDATA_FIELD_LEVEL = 3
	-- local ITEMDATA_FIELD_QUALITY = 2
	-- local ITEMDATA_FIELD_NAME = 2
	-- local ITEMDATA_FIELD_NAME = 2

	local ITEM_FIELDS = WMDB.SCHEMA.ITEM_FIELDS
	local PRICE_FIELDS = WMDB.SCHEMA.PRICE_FIELDS

	wMerchantDisplayTB:Clear()
	
-- if WMDB then
-- 	text = text .. "\nw33zl's Merchant is ok!\n"

	if not searchText or string.len(searchText) == 0 then
		--wMerchantDisplayTest:SetText("No hits (nothing to search for)!\n")
		wMerchantDisplayTB:AddMessage("No hits (nothing to search for)!\n")
		wMerchantDisplayTB:SetDimensions(wMerchantDisplayTB:GetWidth(), 22)
		return
	end

	-- d("begin search")

	if WMDB.Items then
		local text = ""
		local numMatches = 0
		local numActualHits = 0



		for itemKey, item in pairs(WMDB.Items) do
			local startIndex,j = string.find(string.lower(item[ITEM_FIELDS.Name]), string.lower(searchText))
			if startIndex ~= nil then
				-- d("found")
				-- text = text .. "- " .. item[ITEM_FIELDS.Name] .. "\n"
				numMatches = numMatches + 1



				-- local itemKeyPattern = '(%d+):(%d+):(%d+):(%d+)'
				-- local itemID, level, quality, enchantment = string.match(itemKey, itemKeyPattern)

				local itemID, level, quality, enchantment = WM.ParseItemUID(itemKey)


				local link = wMerchant:GetItemLink(itemID, level, quality, enchantment)

				-- local icon, sellPrice, meetsUsageRequirement, equipType, itemStyle = GetItemLinkInfo(link)

				-- --d(link)

				-- --wMerchant.Settings.LastLink = link

				-- icon = "|t20:20:" .. icon .. "|t "

				local icon = WM.GetLinkIconTexture(link, 20)


				
				if WMDB.Prices[itemKey] and WMDB.Prices[itemKey][PRICE_FIELDS.Weighted] then
					numActualHits = numActualHits + 1
					local priceText = WMDB.Prices[itemKey][PRICE_FIELDS.Weighted]
					if priceText then
						priceText = format_thousand(priceText)
					end
					text = text .. icon
					text = text .. wMerchant:GetItemLevelText(quality, level)
					text = text .. link
					text = text .. wMerchant.Resources.GoldCoin
					text = text .. string.format("  |cEFD766%s|r  |c82807F(seen: %i)|r", priceText, WMDB.Prices[itemKey][PRICE_FIELDS.Seen])
					text = text .. "\n"

					--.. item[ITEM_FIELDS.ItemID] .. "=" .. itemID .. ":" .. icon .. ":" .. quality .. ":" .. level .. ":" .. enchantment ..  .. "\n"

				end 

				-- for priceKey, priceValue in pairs(WMDB.Prices) do
				-- 	local i2,j2 = string.find(priceKey, item[ITEM_FIELDS.ItemID], 0)
				-- 	if i2 ~= nil and i2 == 1 then

				-- 		FAULTY >> local pattern = '(%d+)_(%d+)_(%d+)_(%d+)'
				-- 		local itemID, level, quality, enchantment = string.match(priceKey, pattern)

				-- 		local link = wMerchant:GetItemLink(itemID, level, quality, enchantment)

				-- 		local icon, sellPrice, meetsUsageRequirement, equipType, itemStyle = GetItemLinkInfo(link)

				-- 		d(link)

				-- 		wMerchant.Settings.LastLink = link

				-- 		icon = "|t16:16:" .. icon .. "|t "

				-- 		text = text .. item[ITEM_FIELDS.ItemID] .. "=" .. itemID .. ":" .. icon .. ":" .. quality .. ":" .. level .. ":" .. enchantment .. " |t16:16:EsoUI/Art/currency/currency_gold.dds|t " .. priceValue[PRICE_FIELDS.Weighted] .. "\n"


				-- 		--text = text .. link .. "\n"

				-- 		--text = link
				-- 	end
				-- end
			end -- if startindex..

			if numActualHits >= 20 then
				break
			end 
		end -- for


		-- -- d("Num matches: " .. numMatches)
		-- d("Num num actual hits: " .. numActualHits)

		

		if numActualHits > 0 then
			--wMerchantDisplayTest:SetText(text)
			--wMerchantDisplayTB:SetText(text)


			wMerchantDisplayTB:SetMaxHistoryLines(numActualHits + 1)
			wMerchantDisplayTB:AddMessage("|c000000_|r\n" .. text)
			--wMerchantDisplayTB:AddMessage(text)
			--wMerchantDisplayTB:AddMessage("\n|c000000|r")


			if numActualHits > 0 and numActualHits <= 18 then
				-- d(wMerchantDisplayTB:GetNumVisibleLines())
				-- d(wMerchantDisplayTB:GetNumHistoryLines())
				wMerchantDisplayTB:SetDimensions(wMerchantDisplayTB:GetWidth(), numActualHits * 22.3)
				while wMerchantDisplayTB:GetNumVisibleLines() < numActualHits do
					wMerchantDisplayTB:SetDimensions(wMerchantDisplayTB:GetWidth(), wMerchantDisplayTB:GetHeight() + 1)
				end
				-- d(wMerchantDisplayTB:GetNumVisibleLines())
				-- d(wMerchantDisplayTB:GetNumHistoryLines())
			else
				wMerchantDisplayTB:SetDimensions(wMerchantDisplayTB:GetWidth(), 432)
				-- d(wMerchantDisplayTB:GetNumVisibleLines())
				-- d(wMerchantDisplayTB:GetNumHistoryLines())

			end

			if wMerchantDisplayTB:GetNumVisibleLines() < numActualHits then
				wMerchantDisplayTB:AddMessage("... { too many hits, try to be more specific in the search } ...")
			end


		else
			--wMerchantDisplayTest:SetText("No hits!\n")
			wMerchantDisplayTB:AddMessage("No hits!")
			for i=1,18 do
				wMerchantDisplayTB:AddMessage("|c000000|r")
			end
		end

		

		--string.gsub(s, pattern, replace [, n])

--http://lua-users.org/wiki/StringLibraryTutorial
	end
--end
	
end--function DoSearch