--------------------------ZO Obligatory Spam-----------------------------------

-- EULA: "This Add-on is not created by, affiliated with or sponsored by ZeniMax Media Inc. or its affiliates. 
-- The Elder Scrolls® and related logos are registered trademarks or trademarks of ZeniMax Media Inc. in the 
-- United States and/or other countries. All rights reserved."

--------------------------Library Registry-------------------------------------
-- Title: LibReader
-- Author: @deome
-- APIVersion: 100008
-- Version 1.21
-- DependsOn: LibStub

local LibReader = LibStub:NewLibrary("LibReader-1.2", 1)
if not LibReader then do return end end

-------------------------------------------------------------------------------


--------------------------Constant Tables--------------------------------------

local PlaceValues = { ["name"] = 1, ["linkstyle"] = 2, ["linktype"] = 3, ["itemid"] = 4, ["quality"] = 5, ["levelreq"] = 6, ["enchtid"] = 7, 
["mag1"] = 8, ["mag2"] = 9, ["itemstyle"] = 19, ["iscrafted"] = 20, ["isbound"] = 21, ["charge"] = 22, }

local SI_ItemQuality = { SI_ITEMQUALITY1, SI_ITEMQUALITY2, SI_ITEMQUALITY3, SI_ITEMQUALITY4, SI_ITEMQUALITY5, SI_ITEMQUALITY0, }

local SI_ItemStyle = { SI_ITEMSTYLE1, SI_ITEMSTYLE2, SI_ITEMSTYLE3, SI_ITEMSTYLE4, SI_ITEMSTYLE5, SI_ITEMSTYLE6, SI_ITEMSTYLE7, SI_ITEMSTYLE8, 
SI_ITEMSTYLE9, SI_ITEMSTYLE10, SI_ITEMSTYLE11, SI_ITEMSTYLE12, SI_ITEMSTYLE13, SI_ITEMSTYLE14, SI_ITEMSTYLE15, SI_ITEMSTYLE16, SI_ITEMSTYLE17, 
SI_ITEMSTYLE18, SI_ITEMSTYLE19, SI_ITEMSTYLE20, SI_ITEMSTYLE21, SI_ITEMSTYLE22, SI_ITEMSTYLE23, SI_ITEMSTYLE24, SI_ITEMSTYLE25, SI_ITEMSTYLE26, 
SI_ITEMSTYLE27, SI_ITEMSTYLE28, SI_ITEMSTYLE29, SI_ITEMSTYLE30, SI_ITEMSTYLE31, SI_ITEMSTYLE32, SI_ITEMSTYLE33, SI_ITEMSTYLE34, SI_ITEMSTYLE35, 
SI_ITEMSTYLE0, }

local SI_ItemTrait = { SI_ITEMTRAITTYPE1, SI_ITEMTRAITTYPE2, SI_ITEMTRAITTYPE3, SI_ITEMTRAITTYPE4, SI_ITEMTRAITTYPE5, SI_ITEMTRAITTYPE6, 
SI_ITEMTRAITTYPE7, SI_ITEMTRAITTYPE8, SI_ITEMTRAITTYPE9, SI_ITEMTRAITTYPE10, SI_ITEMTRAITTYPE11, SI_ITEMTRAITTYPE12, SI_ITEMTRAITTYPE13, 
SI_ITEMTRAITTYPE14, SI_ITEMTRAITTYPE15, SI_ITEMTRAITTYPE16, SI_ITEMTRAITTYPE17, SI_ITEMTRAITTYPE18, SI_ITEMTRAITTYPE19, SI_ITEMTRAITTYPE20, 
SI_ITEMTRAITTYPE21, SI_ITEMTRAITTYPE22, SI_ITEMTRAITTYPE23, SI_ITEMTRAITTYPE24, SI_ITEMTRAITTYPE0, }

local SI_ItemType = { SI_ITEMTYPE1, SI_ITEMTYPE2, SI_ITEMTYPE3, SI_ITEMTYPE4, SI_ITEMTYPE5, SI_ITEMTYPE6, SI_ITEMTYPE7, SI_ITEMTYPE8, SI_ITEMTYPE9, 
SI_ITEMTYPE10, SI_ITEMTYPE11, SI_ITEMTYPE12, SI_ITEMTYPE13, SI_ITEMTYPE14, SI_ITEMTYPE15, SI_ITEMTYPE16, SI_ITEMTYPE17, SI_ITEMTYPE18, SI_ITEMTYPE19, 
SI_ITEMTYPE20, SI_ITEMTYPE21, SI_ITEMTYPE22, SI_ITEMTYPE23, SI_ITEMTYPE24, SI_ITEMTYPE25, SI_ITEMTYPE26, SI_ITEMTYPE27, SI_ITEMTYPE28, SI_ITEMTYPE29, 
SI_ITEMTYPE30, SI_ITEMTYPE31, SI_ITEMTYPE32, SI_ITEMTYPE33, SI_ITEMTYPE34, SI_ITEMTYPE35, SI_ITEMTYPE36, SI_ITEMTYPE37, SI_ITEMTYPE38, SI_ITEMTYPE39, 
SI_ITEMTYPE40, SI_ITEMTYPE41, SI_ITEMTYPE42, SI_ITEMTYPE43, SI_ITEMTYPE44, SI_ITEMTYPE45, SI_ITEMTYPE46, SI_ITEMTYPE47, SI_ITEMTYPE48, SI_ITEMTYPE49, 
SI_ITEMTYPE50, SI_ITEMTYPE51, SI_ITEMTYPE52, SI_ITEMTYPE53, SI_ITEMTYPE0, }

-------------------------------------------------------------------------------


--------------------------Parsing Functions------------------------------------

function LibReader:ParseItemLinkToTable(ItemLink)
	local name, linkStyle, linktype, itemid, quality, levelreq, enchtid, mag1, mag2, var1, var2, var3, var4, var5, var6, var7, var8, var9, 
	itemstyle, iscrafted, isbound, charge, var10 = ZO_LinkHandler_ParseLink(ItemLink)
	local ParsedItemLink = { name, linkStyle, linktype, itemid, quality, levelreq, enchtid, mag1, mag2, var1, var2, var3, var4, var5, var6, 
	var7, var8, var9, itemstyle, iscrafted, isbound, charge, var10, }
	
	return ParsedItemLink
end

function LibReader:GetLinkValue(ItemLink, val)
	assert(type(val) == "string" or "number", "Bad argument #2 to `GetLinkValue' (string or number expected)")
	
	if ((type(val) == "number") and (val <= 23 and val > 1)) then
		local num = select(val, ZO_LinkHandler_ParseLink(ItemLink))
		return tonumber(num)
		
	elseif ((type(val) == "number") and val == 1) then
		return select(val, ZO_LinkHandler_ParseLink(ItemLink))
		
	elseif (type(val) == "string") then
		local value = zo_strlower(val)
		
		if PlaceValues[value] then
			local num = select(PlaceValues[value], ZO_LinkHandler_ParseLink(ItemLink))
			return tonumber(num)
		else
			return nil
		end
	else
		return nil
	end
end

function LibReader:GetItemLinkQuality(ItemLink)
	local iQuality = GetItemLinkQuality(ItemLink)
	if iQuality == 0 then iQuality = 6 end
	local itemQuality = SI_ItemQuality[iQuality]

	return zo_strformat(itemQuality)
end

function LibReader:GetItemLinkStyle(ItemLink)
	local iStyle = LibReader:GetLinkValue(ItemLink, 19)
	iStyle = tonumber(iStyle)
	if iStyle == 0 then iStyle = 36 end
	local itemStyle = SI_ItemStyle[iStyle]

	return zo_strformat(itemStyle)
end

function LibReader:GetItemLinkTrait(ItemLink)
	local iTrait = GetItemLinkTraitInfo(ItemLink)
	if iTrait == 0 then iTrait = 25 end
	local itemTrait = SI_ItemTrait[iTrait]
	
	return zo_strformat(itemTrait)
end

function LibReader:GetItemLinkType(ItemLink)
	local iType = GetItemLinkItemType(ItemLink)
	if iType == 0 then iType = 54 end
	local itemType = SI_ItemType[iType]
	
	return zo_strformat(itemType)
end

-- Yay. This function is back!
function LibReader:FormatItemName(ItemLink)
	local name = zo_strformat(SI_TOOLTIP_ITEM_NAME, LibReader:GetLinkValue(ItemLink, 1))
	return name
end

-- This is just a convenient place to store these until I have a use for them. The enchant and set info functions are undocumented in the wiki, as far as I know,
-- and I had to just plug and reloadui to figure them out. Annoyingly, "HasEnchant" really only tells you if there's a normal enchant on an item--it comes up as
-- "false" on many unique, named, or set items.
--		local HasEnchant 	= select(1, GetItemLinkEnchantInfo(ItemLink))
--		local EnchtName		= select(2, GetItemLinkEnchantInfo(ItemLink))
--		local EnchtValue	= select(3, GetItemLinkEnchantInfo(ItemLink))
--		local IsSetItem		= select(1, GetItemLinkSetInfo(ItemLink))
--		local SetName		= select(2, GetItemLinkSetInfo(ItemLink))
--		local ItemType		= LibReader:GetItemLinkType(ItemLink)
--		local ItemTrait		= LibReader:GetItemLinkTrait(ItemLink)
--		local ItemStyle		= LibReader:GetItemLinkStyle(ItemLink)
