if ZOX then return end

ZOX = {}

ZOX.QUALITY_WHITE = "white"
ZOX.QUALITY_GREEN = "green"
ZOX.QUALITY_BLUE = "blue"
ZOX.QUALITY_PURPLE = "purple"
ZOX.QUALITY_GOLD = "gold"
ZOX.QUALITY_GRAY = "gray"

ZOX.COLORS = {
	[ZOX.QUALITY_WHITE] = "FFFFFF",
	[ZOX.QUALITY_GREEN] = "FFFFFF",
	[ZOX.QUALITY_BLUE] = "FFFFFF",
	[ZOX.QUALITY_PURPLE] = "FFFFFF",
	[ZOX.QUALITY_GOLD] = "FFFFFF",
}

ZOX.UnknownItemQuality = {}


function ZOX_ItemHandler_GetLevelAndColor(quality, level)

	local calculatedLevel = nil
	local itemColor = nil


	if type(quality) == "string" then
		quality = tonumber(quality)
	end

	if quality == 1 or quality == 177 then -- gray
		calculatedLevel = level
		itemColor = ZOX.QUALITY_GRAY
	-- WHITE
	elseif quality == 0 or quality == 2 or quality == 20 or quality == 25 or quality == 30 or quality == 35 or quality == 36 or quality == 38 or quality == 175 or quality == 176 then -- white (materials?)
		calculatedLevel = level
		itemColor = ZOX.QUALITY_WHITE
	-- GREEN
	elseif quality == 3 or quality == 9 or quality == 10 or quality == 18 or quality == 19 or quality == 20 or quality == 21 or quality == 26 or quality == 31 or quality == 37 or quality == 121 then -- green (materials?) - 9=throphies?
		calculatedLevel = level
		itemColor = ZOX.QUALITY_GREEN
	-- BLUE
	elseif quality == 4 or quality == 7 or quality == 11 or quality == 22 or quality == 27 or quality == 32 or quality == 122 then -- blue (materials?)
		calculatedLevel = level
		itemColor = ZOX.QUALITY_BLUE
	-- PURPLE
	elseif quality == 5 or quality == 8 or quality == 23 or quality == 28 or quality == 33 or quality == 123 then -- purple (materials?)
		calculatedLevel = level
		itemColor = ZOX.QUALITY_PURPLE
	-- GOLD
	elseif quality == 6 or quality == 24 or quality == 29 or quality == 34 or quality == 124 then -- gold (materials?)
		calculatedLevel = level
		itemColor = ZOX.QUALITY_GOLD
	elseif quality >= 12 and quality <= 17 then -- gold
		calculatedLevel = level
		itemColor = ZOX.QUALITY_GOLD
	elseif quality == 49 then -- Unique items
		calculatedLevel = level
		itemColor = ZOX.QUALITY_BLUE
	elseif quality == 50 then -- Named items
		calculatedLevel = level
		itemColor = ZOX.QUALITY_BLUE
	-- WHITE VETERAN
	elseif quality >= 39 and quality <= 48 then -- green veteran
		calculatedLevel = "VR" .. (quality - 38)
		itemColor = ZOX.QUALITY_GREEN
	elseif quality >= 51 and quality <= 60 then -- green veteran
		calculatedLevel = "VR" .. (quality - 50)
		itemColor = ZOX.QUALITY_GREEN
	elseif quality >= 61 and quality <= 70 then -- blue veteran rank
		calculatedLevel = "VR" .. (quality - 60)
		itemColor = ZOX.QUALITY_BLUE
	elseif quality >= 71 and quality <= 80 then -- purple veteran rank
		calculatedLevel = "VR" .. (quality - 70)
		itemColor = ZOX.QUALITY_PURPLE
	elseif quality >= 101 and quality <= 110 then -- gold veteran rank
		calculatedLevel = "VR" .. (quality - 100)
		itemColor = ZOX.QUALITY_GOLD
	elseif quality >= 111 and quality <= 120 then -- white veteran rank
		calculatedLevel = "VR" .. (quality - 110)
		itemColor = ZOX.QUALITY_WHITE
	elseif quality >= 125 and quality <= 134 then -- white veteran rank
		calculatedLevel = "VR" .. (quality - 124)
		itemColor = ZOX.QUALITY_WHITE
	elseif quality >= 81 and quality <= 90 then -- blue veteran rank (??)
		calculatedLevel = "VR" .. (quality - 80)
		itemColor = ZOX.QUALITY_BLUE
	elseif quality >= 91 and quality <= 100 then -- purple veteran rank (??)
		calculatedLevel = "VR" .. (quality - 90)
		itemColor = ZOX.QUALITY_PURPLE
	elseif quality >= 135 and quality <= 144 then -- green veteran (??)
		calculatedLevel = "VR" .. (quality - 134)
		itemColor = ZOX.QUALITY_GREEN
	elseif quality >= 145 and quality <= 154 then -- blue veteran rank (??)
		calculatedLevel = "VR" .. (quality - 144)
		itemColor = ZOX.QUALITY_BLUE
	elseif quality >= 155 and quality <= 164 then -- purple veteran rank (??)
		calculatedLevel = "VR" .. (quality - 154)
		itemColor = ZOX.QUALITY_PURPLE
	elseif quality >= 165 and quality <= 174 then -- gold veteran rank
		calculatedLevel = "VR" .. (quality - 164)
		itemColor = ZOX.QUALITY_GOLD
	elseif quality >= 178 and quality <= 187 then -- white veteran rank
		calculatedLevel = "VR" .. (quality - 177)
		itemColor = ZOX.QUALITY_WHITE
	elseif quality >= 188 and quality <= 197 then -- green veteran
		calculatedLevel = "VR" .. (quality - 187)
		itemColor = ZOX.QUALITY_GREEN
	elseif quality >= 198 and quality <= 207 then -- blue veteran rank
		calculatedLevel = "VR" .. (quality - 197)
		itemColor = ZOX.QUALITY_BLUE
	elseif quality >= 208 and quality <= 217 then -- purple veteran rank
		calculatedLevel = "VR" .. (quality - 207)
		itemColor = ZOX.QUALITY_PURPLE
	elseif quality >= 218 and quality <= 227 then -- gold veteran rank
		calculatedLevel = "VR" .. (quality - 217)
		itemColor = ZOX.QUALITY_GOLD
	-- VR11
	-- VR11 WHITE
	elseif quality == 235 or quality == 236 or quality == 241 then -- white veteran VR11
		calculatedLevel = "VR11"
		itemColor = ZOX.QUALITY_WHITE
	-- VR11 GREEN
	elseif quality == 228 or quality == 229 or quality == 237 then -- green veteran VR11
		calculatedLevel = "VR11"
		itemColor = ZOX.QUALITY_GREEN
	-- VR11 BLUE
	elseif quality == 230 or quality == 232 or quality == 238 or quality == 243 then -- blue veteran VR11
		calculatedLevel = "VR11"
		itemColor = ZOX.QUALITY_BLUE
	-- VR11 PURPLE
	elseif quality == 231 or quality == 233 or quality == 239 or quality == 244 then -- purple veteran VR11
		calculatedLevel = "VR11"
		itemColor = ZOX.QUALITY_PURPLE
	-- VR11 GOLD
	elseif quality == 234 or quality == 240 or quality == 245 then -- gold veteran VR11
		calculatedLevel = "VR11"
		itemColor = ZOX.QUALITY_GOLD
	-- VR12
	-- VR12 WHITE
	elseif quality == 253 or quality == 254 or quality == 259 then -- white veteran VR12
		calculatedLevel = "VR12"
		itemColor = ZOX.QUALITY_WHITE
	-- VR12 GREEN
	elseif quality == 246 or quality == 247 or quality == 255 then -- green veteran VR12
		calculatedLevel = "VR12"
		itemColor = ZOX.QUALITY_GREEN
	-- VR12 BLUE
	elseif quality == 248 or quality == 250 or quality == 256 then -- blue veteran VR12
		calculatedLevel = "VR12"
		itemColor = ZOX.QUALITY_BLUE
	-- VR12 PURPLE
	elseif quality == 249 or quality == 251 or quality == 257 then -- purple veteran VR12
		calculatedLevel = "VR12"
		itemColor = ZOX.QUALITY_PURPLE
	-- VR12 GOLD
	elseif quality == 252 or quality == 258 then -- gold veteran VR12
		calculatedLevel = "VR12"
		itemColor = ZOX.QUALITY_GOLD
	end



-- 65 : veteran Named Blue Boss loots
-- 75 : veteran Named Purple Boss loots
-- 100 : some veteran purple item
-- 124 : Mara Ring
-- 164 : Purple Glyphs
-- 175 : Pets
-- 229 : Set item (multiple set use this id)
-- 247 : Set item (multiple set use this id)
-- 250 : Set item (multiple set use this id)
-- 257 : Set item (multiple set use this id)
-- 258 : Set item (multiple set use this id)		end

	if calculatedLevel == nil or itemColor ==  nil then
		table.insert(ZOX.UnknownItemQuality, {
			["Quality"] = quality,
			["Level"] = level,
			["ItemQualityColor"] = (itemColor or "n/a"),
			["MatchedLevel"] = (calculatedLevel or "n/a"),
		})
	end

	return calculatedLevel, itemColor

end