-- Debug lib 1.0
-- 
-- Copyright (c) 2014 w33zl
--  
-- Permission is hereby granted, free of charge, to any person
-- obtaining a copy of this software and associated documentation
-- files (the "Software"), to deal in the Software without
-- restriction, including without limitation the rights to use,
-- copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the
-- Software is furnished to do so, subject to the following
-- conditions:
--  
-- The above copyright notice and this permission notice shall be
-- included in all copies or substantial portions of the Software.
--  
-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
-- EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
-- OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
-- NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
-- HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-- WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-- FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
-- OTHER DEALINGS IN THE SOFTWARE.

--if DEBUG then return end

local DEBUG = {}

DEBUG.ErrorColor = "FF0000"
DEBUG.WarnColor = "eb6d37"
DEBUG.InfoColor = "AAAAAA"

local function err(text)
	DEBUG.Log(DEBUG.ErrorColor, text)
end

local function log(text)
	DEBUG.Log(DEBUG.InfoColor, text)
end

local function debug(text)
	DEBUG.Log(DEBUG.InfoColor, text)
end

local function warn(text)
	DEBUG.Log(DEBUG.WarnColor, text)

end

function DEBUG.Log(color, text)
	d("|c" .. color .. text .. "|r")
	--CHAT_SYSTEM:AddMessage("|c" .. color .. text .. "|r")
end


local function trace(text, this)

	if not __globalTrace then return end
	if not TRACE then return end

	if this and this.Addon and this.Addon.Name then
		text = this.Addon.Name .. ": " .. text
	end
	d("|cCACACA" .. text .. "|r")

end

DEBUG.err = err
DEBUG.warn = warn

if not _G["err"] then
	_G["err"] = err
end

if not _G["warn"] then
	_G["warn"] = warn
end