--if not wMerchantUI then wMerchantUI = {} end

local UI = wMerchant.UI
local VM = wMerchant
UI.Parent = VM

function UI:Init()
	wMerchantDisplay:SetSimpleAnchorParent(wMerchant.Settings.WindowLeft, wMerchant.Settings.WindowTop)

	--wMerchantDisplayPlayerSales:SetState(BSTATE_DISABLED, false)
	wMerchantDisplayMerchant:SetState(BSTATE_DISABLED, false)

	wMerchantDisplayPlayerSales:SetHandler("OnClicked", function(evt)		
		self.Parent.ShowPlayerSalesFrame()
		self.Parent.HideAllSalesFrame()
		--self:ShowPlayerSales_Click()
	end)

	wMerchantDisplayPrices:SetHandler("OnClicked", function(evt)
		--self:ShowAllSales_Click()
		self.Parent:HidePlayerSalesFrame()
		self.Parent:ShowAllSalesFrame()

	end)

	UI:InitializeResources()

	self:UpdateWindowTitle()

	UI.renderToggleButton()

	UI:renderWelcomeText()

	UI:showHelpOnFirstRun()


	if self.Parent.Settings.AutoOpenOnLogin then
		self.Parent:Show()
	end
	
end


function UI:ShowAllSales_Click()
	self.Parent:HidePlayerSalesFrame()
	self.Parent:ShowAllSalesFrame()
end

function UI:ShowPlayerSales_Click()
	wMerchant.ShowPlayerSalesFrame()
	wMerchant.HideAllSalesFrame()
end

function UI:InitializeResources()
	UI.Textures = {}
	UI.Textures.GoldCoin = "EsoUI/Art/currency/currency_gold.dds"
	UI.Textures.GoldStack = "wMerchant/res/gold.dds"
	UI.Textures.CoinBag = "/EsoUI/Art/icons/item_generic_coinbag.dds"

	wMerchant.Resources = {}
	wMerchant.Resources.GoldCoin = "|t12:12:EsoUI/Art/currency/currency_gold.dds|t"
	wMerchant.Resources.GoldStack = "|t12:12:wMerchant/res/gold.dds|t"
	wMerchant.Resources.CoinBag = "|t12:12:/EsoUI/Art/icons/item_generic_coinbag.dds|t"
end


--- Renders window title
function UI:UpdateWindowTitle()
	if wMerchantDisplayTitle then
		-- local title = wMerchantDisplayTitle:GetText()

		-- title = "w33zl's Merchant" .. " [" .. tablelength(WMDB.Items) .. " items & " ..  WMDB.TransactionCount .. " transactions in db] - BETA"

		-- wMerchantDisplayTitle:SetText(title)


		local numItemsText = format_thousand(WMDB.ItemDataCount)
		local numTransactionsText = comma_value(WMDB.TransactionCount)

		local addonSubTitle = "" --"|cC698B7"

		addonSubTitle = addonSubTitle .. "|cC6B1Bf" .. numItemsText .. "|r items & "
		addonSubTitle = addonSubTitle .. "|cC6B1Bf" .. numTransactionsText .. "|r transactions in db"
		addonSubTitle = addonSubTitle .. "|r"

		wMerchantDisplaySubTitle:SetColor(255, 255, 255, 0.5)
		

		wMerchantDisplaySubTitle:SetText(addonSubTitle)
	end
end--function


function UI:renderWelcomeText()
	local NL = "|c000000|r"
	wMerchantDisplayTB:AddMessage("|cC5C29EWelcome to |r|cFF00AAw33zl's|r |cE8C529Merchant|r |cC5C29Ev" .. wMerchant.Addon.Version ..  "!")
	wMerchantDisplayTB:AddMessage(NL)
	wMerchantDisplayTB:AddMessage("|cC5C29ERight next to the chat frame you will find a gold stack-symbol. Simply click on\n|cC5C29Ethat button to show w33zl's Merchant. You could also bind a custom key\n|cC5C29Ein the Controls configuration.\n")
	wMerchantDisplayTB:AddMessage(NL)
	wMerchantDisplayTB:AddMessage("|cC5C29ETo show this add-on you could also use either of the slash commands:\n|cC5C29E/wm or /merchant.\n")
	wMerchantDisplayTB:AddMessage(NL)
	wMerchantDisplayTB:AddMessage("|cC5C29EThe next time you log in w33zl's Merchant will have been updated with fresh\n|cC5C29Etransactions giving you even more accurate price.\n")
	wMerchantDisplayTB:AddMessage(NL)
	wMerchantDisplayTB:AddMessage("|cC5C29EAre you ready? simply type any search text in the search field above.\n")
	wMerchantDisplayTB:AddMessage(NL)
	wMerchantDisplayTB:AddMessage("|cC5C29EGood luck with your trading!\n")
	wMerchantDisplayTB:AddMessage(NL)

end

function UI:showHelpOnFirstRun()
	local NL = "\n|c000000_|r"

	if wMerchant.Settings.IsFirstRun then
		wMerchant.Settings.IsFirstRun = false

		wMerchantDisplayTB:AddMessage("|c95926ENote: This window automatically opened since this is the first time you run\n|c95926Ethis add-on. The next time you log in you must manually open this window.|r")
		wMerchantDisplayTB:AddMessage(NL)

		wMerchant:Show()
		wMerchantDisplaySearchBox:LoseFocus()
	else
		-- simply write some empty lines instead
		wMerchantDisplayTB:AddMessage(NL)
		wMerchantDisplayTB:AddMessage(NL)
		wMerchantDisplayTB:AddMessage(NL)

	end

end



function UI.renderToggleButton()
	local ctrl = WINDOW_MANAGER:CreateControl("wMerchant_ShowButton",ZO_ChatWindowNotifications,CT_BUTTON)
	ctrl:SetDimensions(20,20)
	ctrl:SetDrawLayer(3)
	ctrl:SetHidden(false)
	ctrl.text = "w33zl's Merchant"
	ctrl:SetNormalTexture("wMerchant/res/gold.dds")
	ctrl:SetMouseOverTexture("wMerchant/res/gold.dds")
	--ctrl:SetAnchor(LEFT,ZO_ChatWindowNotifications,RIGHT,55,0) -- respect CraftStore
	ctrl:SetAnchor(LEFT,ZO_ChatWindowNotifications,RIGHT,93,-2) -- respect CraftStore & AlphaTools
	ctrl:SetHandler("OnClicked",function() wMerchant:Toggle() end)
	ctrl:SetHandler("OnMouseEnter",function(self) ZO_Tooltips_ShowTextTooltip(self,TOP,self.text) end)
	ctrl:SetHandler("OnMouseExit",function(self) ZO_Tooltips_HideTextTooltip() end)
end